"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var RX = require("reactxp");
var Grader_1 = require("../appUtilities/Grader");
var styles = {
    row: RX.Styles.createViewStyle({
        flexDirection: 'row'
    }),
    entry: RX.Styles.createTextStyle({
        width: 20,
        height: 20,
        margin: 10,
        borderColor: 'black',
        borderStyle: "solid",
        borderWidth: 1,
        borderRadius: 3,
        textAlign: 'center',
        textAlignVertical: 'center'
    })
};
var rows = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
var ProgressChart = (function (_super) {
    __extends(ProgressChart, _super);
    function ProgressChart() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ProgressChart.prototype.render = function () {
        return (RX.createElement(RX.View, null,
            RX.createElement(RX.Text, null,
                "Progress Report for ",
                this.props.questionType),
            RX.createElement(RX.View, null, this.renderBody())));
    };
    ProgressChart.prototype.getSign = function () {
        if (this.props.questionType === 'multiplication') {
            return (RX.createElement(RX.Text, null, " \u00D7 "));
        }
        else {
            return (RX.createElement(RX.Text, null, " \u00F7 "));
        }
    };
    ProgressChart.prototype.renderBody = function () {
        var _this = this;
        return (RX.createElement(RX.View, null,
            RX.createElement(RX.View, { style: styles.row },
                RX.createElement(RX.Text, { style: styles.entry }, this.getSign()),
                RX.createElement(RX.Text, { style: styles.entry }, "1"),
                RX.createElement(RX.Text, { style: styles.entry }, "2"),
                RX.createElement(RX.Text, { style: styles.entry }, "3"),
                RX.createElement(RX.Text, { style: styles.entry }, "4"),
                RX.createElement(RX.Text, { style: styles.entry }, "5"),
                RX.createElement(RX.Text, { style: styles.entry }, "6"),
                RX.createElement(RX.Text, { style: styles.entry }, "7"),
                RX.createElement(RX.Text, { style: styles.entry }, "8"),
                RX.createElement(RX.Text, { style: styles.entry }, "9"),
                RX.createElement(RX.Text, { style: styles.entry }, "10")),
            rows.map(function (row, index) {
                return _this.renderViewRow(row, index);
            })));
    };
    ProgressChart.prototype.renderViewRow = function (b, index) {
        var _this = this;
        return (RX.createElement(RX.View, { key: index.toString(), style: styles.row },
            RX.createElement(RX.Text, { style: styles.entry }, b),
            rows.map(function (row, rowIndex) {
                return _this.renderViewGrade(row, b, rowIndex);
            })));
    };
    ProgressChart.prototype.renderViewGrade = function (a, b, index) {
        var grade = Grader_1.default.Grade(this.props.questionType, a, b);
        return (RX.createElement(RX.Text, { key: index.toString(), style: this.getStyle(grade) }));
    };
    ProgressChart.prototype.getStyle = function (grade) {
        return RX.Styles.createTextStyle({
            backgroundColor: grade.getRGB(),
            width: 20,
            height: 20,
            margin: 10,
            borderColor: 'black',
            borderStyle: "solid",
            borderWidth: 1,
            borderRadius: Math.floor(grade.averageTime)
        }, false);
    };
    ProgressChart.prototype.renderTableBody = function () {
        var _this = this;
        return (RX.createElement("tbody", null,
            RX.createElement("tr", null,
                RX.createElement("td", null),
                RX.createElement("td", null, "1"),
                RX.createElement("td", null, "2"),
                RX.createElement("td", null, "3"),
                RX.createElement("td", null, "4"),
                RX.createElement("td", null, "5"),
                RX.createElement("td", null, "6"),
                RX.createElement("td", null, "7"),
                RX.createElement("td", null, "8"),
                RX.createElement("td", null, "9"),
                RX.createElement("td", null, "10")),
            rows.map(function (row, index) {
                return _this.renderRow(row, index);
            })));
    };
    ProgressChart.prototype.renderRow = function (b, index) {
        var _this = this;
        console.log("Rendering row " + b);
        return (RX.createElement("tr", { key: index },
            RX.createElement("td", null, b),
            rows.map(function (row, rowIndex) {
                return _this.renderGrade(row, b, rowIndex);
            })));
    };
    ProgressChart.prototype.renderGrade = function (a, b, index) {
        console.log("\tRendering grade " + a + ", " + b);
        var grade = Grader_1.default.Grade(this.props.questionType, a, b);
        return (RX.createElement("td", { key: index, style: grade.color() }));
    };
    return ProgressChart;
}(RX.Component));
exports.default = ProgressChart;
//# sourceMappingURL=ProgressChart.js.map